Package org.htmlunit.html

# Class HtmlSelectableTextInput

java.lang.Object
org.htmlunit.html.DomNode
org.htmlunit.html.DomNamespaceNode
org.htmlunit.html.DomElement
org.htmlunit.html.HtmlElement
org.htmlunit.html.HtmlInput
org.htmlunit.html.HtmlSelectableTextInput

All Implemented Interfaces:
  `Serializable`, `Cloneable`, `DisabledElement`, `FormFieldWithNameHistory`, `org.htmlunit.html.impl.SelectableTextInput`, `SubmittableElement`, `ValidatableElement`, `Element`, `Node`

Direct Known Subclasses:
  `HtmlDateInput`, `HtmlEmailInput`, `HtmlNumberInput`, `HtmlPasswordInput`, `HtmlTelInput`, `HtmlTextInput`, `HtmlTimeInput`, `HtmlUrlInput`

public abstract class HtmlSelectableTextInput extends HtmlInput implements org.htmlunit.html.impl.SelectableTextInput
Abstract parent class to share `SelectableTextInput` implementation and typing support.

See Also:
  - Serialized Form

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class org.htmlunit.html.HtmlElement

  `HtmlElement.DisplayStyle`

  ## Nested classes/interfaces inherited from class org.htmlunit.html.DomElement

  `DomElement.ChildElementsIterator`

  ## Nested classes/interfaces inherited from class org.htmlunit.html.DomNode

  `DomNode.ChildIterator, DomNode.DescendantDomElementsIterator, DomNode.DescendantDomNodesIterator, DomNode.DescendantElementsIterator<T extends DomNode>, DomNode.DescendantHtmlElementsIterator`

- ## Field Summary

  ### Fields inherited from class org.htmlunit.html.HtmlInput

  `TAG_NAME`

  ### Fields inherited from class org.htmlunit.html.HtmlElement

  `ATTRIBUTE_CHECKED, ATTRIBUTE_HIDDEN, ATTRIBUTE_REQUIRED, TAB_INDEX_OUT_OF_BOUNDS`

  ### Fields inherited from class org.htmlunit.html.DomElement

  `ATTRIBUTE_NOT_DEFINED, ATTRIBUTE_VALUE_EMPTY, ID_ATTRIBUTE, NAME_ATTRIBUTE, SRC_ATTRIBUTE, TYPE_ATTRIBUTE, VALUE_ATTRIBUTE`

  ### Fields inherited from class org.htmlunit.html.DomNode

  `PROPERTY_ELEMENT, READY_STATE_COMPLETE, READY_STATE_INTERACTIVE, READY_STATE_LOADED, READY_STATE_LOADING, READY_STATE_UNINITIALIZED`

  ### Fields inherited from interface org.htmlunit.html.DisabledElement

  `ATTRIBUTE_DISABLED`

  ### Fields inherited from interface org.w3c.dom.Node

  `ATTRIBUTE_NODE, CDATA_SECTION_NODE, COMMENT_NODE, DOCUMENT_FRAGMENT_NODE, DOCUMENT_NODE, DOCUMENT_POSITION_CONTAINED_BY, DOCUMENT_POSITION_CONTAINS, DOCUMENT_POSITION_DISCONNECTED, DOCUMENT_POSITION_FOLLOWING, DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC, DOCUMENT_POSITION_PRECEDING, DOCUMENT_TYPE_NODE, ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, NOTATION_NODE, PROCESSING_INSTRUCTION_NODE, TEXT_NODE`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `DomNode`
  `cloneNode(boolean deep)`
  `protected void`
  `doType(char c, boolean lastType)`
  Performs the effective type action, called after the keyPress event and before the keyUp event.
  `protected void`
  `doType(int keyCode, boolean lastType)`
  Performs the effective type action, called after the keyPress event and before the keyUp event.
  `String`
  `getSelectedText()`
  Returns the selected text in this element, or `null` if there is no selected text in this element.
  `int`
  `getSelectionEnd()`
  Returns the end position of the selected text in this element.
  `int`
  `getSelectionStart()`
  Returns the start position of the selected text in this element.
  `String`
  `getText()`
  Returns all of the text in this element.
  `void`
  `reset()`
  Returns the value of this element to the default value or checked state (usually what it was at the time the page was loaded, unless it has been modified via JavaScript).
  `void`
  `select()`
  Focuses this element and selects all of its text.
  `void`
  `setSelectionEnd(int selectionEnd)`
  Sets the end position of the selected text in this element.
  `void`
  `setSelectionStart(int selectionStart)`
  Sets the start position of the selected text in this element.
  `void`
  `setText(String text)`
  Sets the text in this element.
  `void`
  `setValue(String newValue)`
  Sets the value.
  `protected void`
  `typeDone(String newValue, boolean notifyAttributeChangeListeners)`
  Called from `DoTypeProcessor`.

  ### Methods inherited from class org.htmlunit.html.HtmlInput

  `adjustValueAfterTypeChange, changeType, focus, getAccept, getAcceptAttribute, getAccessKeyAttribute, getAlignAttribute, getAltAttribute, getAutocomplete, getCheckedAttribute, getDefaultStyleDisplay, getDefaultValue, getDisabledAttribute, getInternalValue, getMax, getMaxLength, getMaxLengthAttribute, getMin, getMinLength, getMinLengthAttribute, getNameAttribute, getNewNames, getOnBlurAttribute, getOnChangeAttribute, getOnFocusAttribute, getOnSelectAttribute, getOriginalName, getPattern, getPlaceholder, getRawValue, getReadOnlyAttribute, getSize, getSizeAttribute, getSrc, getSrcAttribute, getStep, getSubmitNameValuePairs, getTabIndexAttribute, getType, getTypeAttribute, getUseMapAttribute, getValue, getValueAttribute, handles, hasPatternMismatchValidityState, isBlankPatternValidated, isCheckable, isChecked, isCustomErrorValidityState, isCustomValidityValid, isDefaultChecked, isDisabled, isFormNoValidate, isMinMaxLengthSupported, isPatternSupported, isReadOnly, isRequiredSupported, isSubmitable, isTooShortValidityState, isValid, isValidValidityState, isValueMissingValidityState, markValueDirty, propagateClickStateUpdateToParent, removeFocus, setAccept, setAttributeNS, setAutocomplete, setChecked, setCustomValidity, setDefaultValue, setFormNoValidate, setMax, setMaxLength, setMin, setMinLength, setPattern, setPlaceholder, setRawValue, setReadOnly, setSize, setSrcAttribute, setStep, setValueAttribute, unmarkValueDirty, valueAttributeChanged, valueModifiedByJavascript, willValidate`

  ### Methods inherited from class org.htmlunit.html.HtmlElement

  `acceptChar, addHtmlAttributeChangeListener, appendChildIfNoneExists, checkChildHierarchy, detach, fireHtmlAttributeAdded, fireHtmlAttributeRemoved, fireHtmlAttributeReplaced, getCanonicalXPath, getElementsByAttribute, getEnclosingElement, getEnclosingForm, getEnclosingFormOrDie, getLangAttribute, getNodeName, getOnClickAttribute, getOnDblClickAttribute, getOneHtmlElementByAttribute, getOnKeyDownAttribute, getOnKeyPressAttribute, getOnKeyUpAttribute, getOnMouseDownAttribute, getOnMouseMoveAttribute, getOnMouseOutAttribute, getOnMouseOverAttribute, getOnMouseUpAttribute, getSrcAttributeNormalized, getTabIndex, getTextDirectionAttribute, getXmlLangAttribute, hasEventHandlers, isAltPressed, isAttributeCaseSensitive, isCtrlPressed, isDisplayed, isHidden, isOptional, isRequired, isShiftPressed, isSubmittableByEnter, notifyAttributeChangeListeners, removeAttribute, removeChild, removeHtmlAttributeChangeListener, setAttributeNode, setHidden, setHidden, setOwningForm, setRequired, type, type, type, type`

  ### Methods inherited from class org.htmlunit.html.DomElement

  `blur, click, click, click, click, click, dblClick, dblClick, doClickFireChangeEvent, doClickFireClickEvent, doClickStateUpdate, fireEvent, fireEvent, getAttribute, getAttributeDirect, getAttributeNode, getAttributeNodeNS, getAttributeNS, getAttributes, getAttributesMap, getChildElementCount, getChildElements, getElementsByTagName, getElementsByTagNameNS, getEventTargetElement, getFirstElementChild, getId, getLastElementChild, getNodeType, getSchemaTypeInfo, getStaticElementsByTagName, getStyleElement, getStyleElementCaseInSensitive, getStyleMap, getTagName, hasAttribute, hasAttributeNS, hasAttributes, isDisabledElementAndDisabled, isEmptyXmlTagExpanded, isMouseOver, isStateUpdateFirst, matches, mouseDown, mouseDown, mouseMove, mouseMove, mouseOut, mouseOut, mouseOver, mouseOver, mouseUp, mouseUp, preventDefault, printOpeningTagContentAsXml, printXml, removeAttributeNode, removeAttributeNS, removeStyleAttribute, replaceStyleAttribute, rightClick, rightClick, setAttribute, setAttributeNodeNS, setAttributeNS, setDefaults, setId, setIdAttribute, setIdAttributeNode, setIdAttributeNS, setInnerHtml, setNodeValue, toString, writeStyleToElement`

  ### Methods inherited from class org.htmlunit.html.DomNamespaceNode

  `getLocalName, getLowercaseName, getNamespaceURI, getPrefix, getQualifiedName, processImportNode, setPrefix`

  ### Methods inherited from class org.htmlunit.html.DomNode

  `addCharacterDataChangeListener, addDomChangeListener, appendChild, asNormalizedText, asXml, basicRemove, closest, compareDocumentPosition, fireCharacterDataChanged, fireNodeAdded, fireNodeDeleted, getAncestors, getBaseURI, getByXPath, getByXPath, getChildNodes, getChildren, getDescendants, getDomElementDescendants, getEndColumnNumber, getEndLineNumber, getFeature, getFirstByXPath, getFirstByXPath, getFirstChild, getHtmlElementDescendants, getHtmlPageOrNull, getIndex, getLastChild, getNextElementSibling, getNextSibling, getNodeValue, getOwnerDocument, getPage, getParentNode, getPreviousElementSibling, getPreviousSibling, getReadyState, getScriptableObject, getSelectorList, getStartColumnNumber, getStartLineNumber, getTextContent, getUserData, getVisibleText, hasChildNodes, hasFeature, insertBefore, insertBefore, isAncestorOf, isAncestorOfAny, isAttachedToPage, isDefaultNamespace, isEqualNode, isSameNode, isSupported, lookupNamespaceURI, lookupPrefix, mayBeDisplayed, normalize, notifyIncorrectness, onAddedToDocumentFragment, onAddedToPage, onAllChildrenAddedToPage, parseHtmlSnippet, printChildrenAsXml, querySelector, querySelectorAll, quietlyRemoveAndMoveChildrenTo, remove, removeAllChildren, removeCharacterDataChangeListener, removeChild, removeDomChangeListener, replace, replaceChild, setEndLocation, setParentNode, setReadyState, setScriptableObject, setStartLocation, setTextContent, setUserData`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface org.w3c.dom.Node

  `appendChild, compareDocumentPosition, getBaseURI, getChildNodes, getFeature, getFirstChild, getLastChild, getLocalName, getNamespaceURI, getNextSibling, getNodeValue, getOwnerDocument, getParentNode, getPrefix, getPreviousSibling, getTextContent, getUserData, hasChildNodes, insertBefore, isDefaultNamespace, isEqualNode, isSameNode, isSupported, lookupNamespaceURI, lookupPrefix, normalize, removeChild, replaceChild, setPrefix, setTextContent, setUserData`

  ### Methods inherited from interface org.htmlunit.html.impl.SelectableTextInput

  `focus, getPage`

  ### Methods inherited from interface org.htmlunit.html.SubmittableElement

  `setDefaultChecked`

  ### Methods inherited from interface org.htmlunit.html.ValidatableElement

  `hasBadInputValidityState, hasRangeOverflowValidityState, hasRangeUnderflowValidityState, hasTypeMismatchValidityState, isStepMismatchValidityState, isTooLongValidityState`

- ## Method Details

  - ### setValue

    public void setValue(String newValue)
    Sets the value.
    Overrides:
      `setValue` in class `HtmlInput`
    Parameters:
      `newValue` - the new value

  - ### doType

    protected void doType(char c, boolean lastType)
    Performs the effective type action, called after the keyPress event and before the keyUp event.
    Overrides:
      `doType` in class `HtmlElement`
    Parameters:
      `c` - the character you with to simulate typing
      `lastType` - is this the last character to type

  - ### doType

    protected void doType(int keyCode, boolean lastType)
    Performs the effective type action, called after the keyPress event and before the keyUp event.

    An example of predefined values is `KeyboardEvent.DOM_VK_PAGE_DOWN`.

    Overrides:
      `doType` in class `HtmlElement`
    Parameters:
      `keyCode` - the key code wish to simulate typing
      `lastType` - is this the last to type

  - ### typeDone

    protected void typeDone(String newValue, boolean notifyAttributeChangeListeners)
    Called from `DoTypeProcessor`.
    Overrides:
      `typeDone` in class `HtmlElement`
    Parameters:
      `newValue` - the new value
      `notifyAttributeChangeListeners` - to notify the associated `HtmlAttributeChangeListener`s

  - ### setText

    public void setText(String text)
    Sets the text in this element.
    Specified by:
      `setText` in interface `org.htmlunit.html.impl.SelectableTextInput`
    Parameters:
      `text` - the text to put in this element

  - ### getText

    public String getText()
    Returns all of the text in this element.
    Specified by:
      `getText` in interface `org.htmlunit.html.impl.SelectableTextInput`
    Returns:
      all of the text in this element

  - ### select

    public void select()
    Focuses this element and selects all of its text.
    Specified by:
      `select` in interface `org.htmlunit.html.impl.SelectableTextInput`

  - ### getSelectedText

    public String getSelectedText()
    Returns the selected text in this element, or `null` if there is no selected text in this element.
    Specified by:
      `getSelectedText` in interface `org.htmlunit.html.impl.SelectableTextInput`
    Returns:
      the selected text in this element, or `null` if there is no selected text in this element

  - ### getSelectionStart

    public int getSelectionStart()
    Returns the start position of the selected text in this element.
    Specified by:
      `getSelectionStart` in interface `org.htmlunit.html.impl.SelectableTextInput`
    Returns:
      the start position of the selected text in this element

  - ### setSelectionStart

    public void setSelectionStart(int selectionStart)
    Sets the start position of the selected text in this element.
    Specified by:
      `setSelectionStart` in interface `org.htmlunit.html.impl.SelectableTextInput`
    Parameters:
      `selectionStart` - the start position of the selected text in this element

  - ### getSelectionEnd

    public int getSelectionEnd()
    Returns the end position of the selected text in this element.
    Specified by:
      `getSelectionEnd` in interface `org.htmlunit.html.impl.SelectableTextInput`
    Returns:
      the end position of the selected text in this element

  - ### setSelectionEnd

    public void setSelectionEnd(int selectionEnd)
    Sets the end position of the selected text in this element.
    Specified by:
      `setSelectionEnd` in interface `org.htmlunit.html.impl.SelectableTextInput`
    Parameters:
      `selectionEnd` - the end position of the selected text in this element

  - ### reset

    public void reset()
    Returns the value of this element to the default value or checked state (usually what it was at the time the page was loaded, unless it has been modified via JavaScript).
    Specified by:
      `reset` in interface `SubmittableElement`
    Overrides:
      `reset` in class `HtmlInput`
    See Also:
      - `HtmlInput.reset()`

  - ### cloneNode

    public DomNode cloneNode(boolean deep)
    Specified by:
      `cloneNode` in interface `Node`
    Overrides:
      `cloneNode` in class `HtmlInput`